#include <stdio.h>
#include <stdlib.h>
#include <string.h>




static unsigned char mf2_header[] = {
	'C', 'P', 'X', ' ', 'O', 'n', 'e', '-',
	'P', 'a', 's', 's', ' ', 'S', 'D', ' ',
	' ', ' ', ' ', ' ',
	0x00, 0x00, 0x01, 0x00,
};


static unsigned char mf3_header[] = {
	'C', 'X', 0x00, 0x00,
};




static int expand(unsigned char *dest, unsigned char *src, int dest_size, int src_size, int flag){
	int s_ofs, d_ofs;

	s_ofs = 0;
	d_ofs = 0;

	while(src_size > s_ofs){
		if(src[s_ofs] != flag){
			dest[d_ofs] = src[s_ofs];
			d_ofs += 1;
			s_ofs += 1;
		}
		else if(0 == src[s_ofs + 1]){
			dest[d_ofs] = src[s_ofs];
			d_ofs += 1;
			s_ofs += 2;
		}
		else{
			int e_ofs, e_size;
			e_ofs = (d_ofs - src[s_ofs + 1]);
			e_size = (src[s_ofs + 2] + 3);
			while(0 < e_size){
				dest[d_ofs] = dest[e_ofs];
				d_ofs += 1;
				e_ofs += 1;
				e_size -= 1;
			}
			s_ofs += 3;
		}
	}

	return d_ofs;
}




int main(int argc, char *argv[]){
	unsigned char *src, *dest;
	int size, dest_size;


	if(2 > argc){
		exit(0);
	}


	{
		FILE *fp;
		fp = fopen(argv[1], "rb");
		if(NULL == fp){
			exit(1);
		}
		fseek(fp, 0, SEEK_END);
		size = ftell(fp);
		src = (unsigned char*)malloc(size);
		if(NULL == src){
			fclose(fp);
			exit(1);
		}
		fseek(fp, 0, SEEK_SET);
		fread(src, 1, size, fp);
		fclose(fp);
	}


	{
		unsigned char *p;
		int cmp_size;
		int flag;
		
		p = src;
		if(0 == memcmp(p, mf2_header, sizeof(mf2_header))){
			p += sizeof(mf2_header);
		}
		else if(0 == memcmp(p, mf3_header, sizeof(mf3_header))){
			p += sizeof(mf3_header);
		}
		else{
			free(p);
			exit(1);
		}

		dest_size = (p[0] + (p[1] << 8));
		cmp_size = (p[2] + (p[3] << 8));
/*		flag = (p[5] + (p[4] << 8));	*/
		flag = p[5];

		dest = (unsigned char*)malloc(dest_size);
		if(NULL == dest){
			free(src);
			exit(1);
		}

		p += 6;
		dest_size = expand(dest, p, dest_size, cmp_size, flag);
	}


	if(0 < dest_size){
		FILE *fp;
		char *p;
		p = argv[1];
		if(3 <= argc){
			p = argv[2];
		}
		fp = fopen(p, "wb");
		fwrite(dest, 1, dest_size, fp);
		fclose(fp);
	}


	free(dest);
	free(src);

	exit(0);
}
