#include <stdio.h>
#include <stdlib.h>
#include <string.h>


static char ppc_head[] = "ADPCM DATA for  PMD ver.4.4-  ";

static char padding[32] = {
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88,
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88,
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88,
	0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88, 0x88,
};



static unsigned int get_word(unsigned char *p){
	unsigned int t;
	t = p[1];
	t = ((t << 8) | p[0]);
	return t;
}

static void put_word(unsigned char *p, unsigned int t){
	p[0] = (t & 0xff);
	p[1] = ((t >> 8) & 0xff);
}



int main(int argc, char *argv[]){
	unsigned char *src;
	int size;


	if(2 > argc){
		exit(0);
	}


	{
		FILE *fp;
		fp = fopen(argv[1], "rb");
		if(NULL == fp){
			exit(1);
		}
		fseek(fp, 0, SEEK_END);
		size = ftell(fp);
		src = (unsigned char*)malloc(size);
		if(NULL == src){
			fclose(fp);
			exit(1);
		}
		fseek(fp, 0, SEEK_SET);
		fread(src, 1, size, fp);
		fclose(fp);
	}


	{
		int ofs, t_ofs;
		int t;
		unsigned char buf[0x400];
		ofs = 2;
		t_ofs = 0;
		while(0x202 > ofs){
			put_word((buf + t_ofs), get_word(src + ofs));
			put_word((buf + t_ofs + 2), get_word(src + ofs + 0x200));
			ofs += 2;
			t_ofs += 4;
		}
		memcpy((src + 2), buf, 0x400);
	}


	{
		char t_name[32];
		int ofs, base_ofs;
		FILE *fp;

		if(3 <= argc){
			strcpy(t_name, argv[2]);
		}
		else{
			char *p;
			strcpy(t_name, argv[1]);
			p = strrchr(t_name, '.');
			if(NULL == p){
				p = (t_name + strlen(t_name));
			}
			if(('/' == p[1]) || ('\\' == p[1])){
				p = (t_name + strlen(t_name));
			}
			strcpy(p, ".PPC");
		}
		fp = fopen(t_name, "wb");
		fwrite(ppc_head, 1, 30, fp);
		fwrite(src, 1, 0x402, fp);

		base_ofs = 0x26;
		ofs = 2;
		while(0x402 > ofs){
			int t_ofs, t_size;

			t_ofs = get_word(src + ofs);
			t_size = get_word(src + ofs + 2);
			if((0 == t_ofs) && (0xffff == t_size)){
				ofs += 4;
				continue;
			}
			t_size = ((t_size - t_ofs + 1) << 2);
			t_ofs <<= 2;

			fwrite((src + t_ofs + 0x402), 1, t_size, fp);
			if(0 != (t_size & 0x1f)){
				fwrite(padding, 1, (32 - (t_size & 0x1f)), fp);
			}
			t_size = (((t_size + 0x1f) & ~0x1f) >> 5);

			put_word((src + ofs), base_ofs);
			put_word((src + ofs + 2), (base_ofs + t_size - 1));
			base_ofs += t_size;

			ofs += 4;
		}
		put_word(src, base_ofs);

		fseek(fp, 30, SEEK_SET);
		fwrite(src, 1, 0x402, fp);

		fclose(fp);
	}


	free(src);

	exit(0);
}
